import os

class Config:
  db_host = ""
  db_port = 3306
  db_username = ""
  db_password = ""
  db_database = ""

  bot_api_id = ""
  bot_api_hash = ""
  bot_token = ""

  tmp_dir = ""

  backup_channel_id = ""

  rate_limit_count = 10
  rate_limit_expire = 60

  genius_access_token = ""

  fetcher_interval = 10

  admin_user_ids = []

  def __init__(self):
    self.db_host = os.environ["DB_HOST"]
    self.db_username = os.environ["DB_USER"]
    self.db_password = os.environ["DB_PASSWORD"]
    self.db_database = os.environ["DB_NAME"]
    self.db_port = os.environ["DB_PORT"]

    self.bot_api_id = int(os.environ["PYROGRAM_API_ID"])
    self.bot_api_hash = os.environ["PYROGRAM_API_HASH"]
    self.bot_token = os.environ["PYROGRAM_BOT_TOKEN"]

    self.tmp_dir = os.environ["TMP_DIR"]

    self.backup_channel_id = os.environ["BACKUP_CHANNEL_ID"]

    self.rate_limit_count = int(os.environ["RATE_LIMIT_COUNT"])
    self.rate_limit_expire = int(os.environ["RATE_LIMIT_EXPIRE"])

    self.genius_access_token = os.environ["GENIUS_ACCESS_TOKEN"]

    self.fetcher_interval = int(os.environ["FETCHER_INTERVAL"])

    if os.environ["ADMIN_USER_IDS"]:
      admin_user_ids = os.environ["ADMIN_USER_IDS"].split(',')
      for id in admin_user_ids:
        self.admin_user_ids.append(int(id))
