from pyrogram.types import Message, CallbackQuery
from pyrogram.client import Client

from services.repo import ServiceRepo
from common.states import States
from data.admin.main_menu import main_menu

async def error_handler(admin_id, message: Message, service_repo: ServiceRepo):
  service_repo.user_service.set_state(admin_id, States.ADMIN_STARTED)
  await message.reply_text(
    text=f"""
خطایی رخ داده است!

{main_menu["text"]}
""",
    reply_markup=main_menu["reply_markup"]
  )

async def handle_message(bot: Client, message: Message, service_repo: ServiceRepo):
  offset = 0
  limit = 100
  while True:
    try:
      users = service_repo.user_service.get_users(offset, limit)
    except:
      await error_handler(message.from_user.id, message, service_repo)
      return
    
    offset = offset + limit
    if users and len(users):
      for user in users:
        try:
          await bot.send_message(
            chat_id=user[0],
            text=message.text
          )
        except:
          pass

    if not users or not len(users) or len(users) < limit:
      break

  service_repo.user_service.set_state(message.from_user.id, States.ADMIN_STARTED)
  await message.reply_text(
    text=f"""
پیام با موفقیت ارسال شد

{main_menu["text"]}
""",
    reply_markup=main_menu["reply_markup"]
  )

async def handle_callback(update: CallbackQuery, service_repo: ServiceRepo):
  if update.data == "cancel":
    service_repo.user_service.set_state(update.from_user.id, States.ADMIN_STARTED)
    await update.message.reply_text(
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )