from pyrogram.types import CallbackQuery, Message

from data.admin.main_menu import main_menu
from data.admin.plan_list import plan_list
from services.repo import ServiceRepo
from common.states import States

async def handle_message(message: Message, service_repo: ServiceRepo):
  pass

async def handle_callback(update: CallbackQuery, service_repo: ServiceRepo):
  data = update.data
  if data == "enable_plans":
    service_repo.db_conf_service.toggle_plans(True)
    await update.message.edit_text(text="با موفقیت فعال شد")
    service_repo.user_service.set_state(update.from_user.id, States.ADMIN_STARTED)
    await update.message.reply_text(
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )

  elif data == "disable_plans":
    service_repo.db_conf_service.toggle_plans(False)
    await update.message.edit_text(text="با موفقیت غیرفعال شد")
    service_repo.user_service.set_state(update.from_user.id, States.ADMIN_STARTED)
    await update.message.reply_text(
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )
  
  elif data == "manage_plans":
    plans = service_repo.plan_service.get_plans()
    service_repo.user_service.set_state(update.from_user.id, States.ADMIN_VIEWING_PLAN_LIST)
    dialog = plan_list(plans)
    await update.message.edit_text(text=dialog["text"], reply_markup=dialog["reply_markup"])

  elif data == "back":
    service_repo.user_service.set_state(update.from_user.id, States.ADMIN_STARTED)
    await update.message.edit_text(
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )
