from pyrogram.types import CallbackQuery, Message

from data.admin.main_menu import main_menu
from data.admin.plan_list import plan_list
from services.repo import ServiceRepo
from common.states import States

async def handle_message(message: Message, service_repo: ServiceRepo):
  price = ""
  for num in message.text:
    if num >= "0" and num <= "9":
      price += num
    elif num >= '۰' and num <= '۹':
      price += chr(ord(num) - ord('۰') + ord('0'))
    else:
      await message.reply_text(text="لطفا یک عدد معتبر وارد کنید")
      return
    
  price = int(price)
  service_repo.plan_service.set_price(price)
  await message.reply_text("پلن با موفقیت ایجاد شد")
  service_repo.user_service.set_state(message.from_user.id, States.ADMIN_STARTED)
  await message.reply_text(text=main_menu["text"], reply_markup=main_menu["reply_markup"])

async def handle_callback(update: CallbackQuery, service_repo: ServiceRepo):
  pass