from pyrogram.types import CallbackQuery, Message

from data.admin.main_menu import main_menu
from data.admin.plan_list import plan_list
from services.repo import ServiceRepo
from common.states import States

async def handle_message(message: Message, service_repo: ServiceRepo):
  pass

async def handle_callback(update: CallbackQuery, service_repo: ServiceRepo):
  data = update.data
  user_id = update.from_user.id
  if data == "new_plan":
    plans = service_repo.plan_service.get_plans()
    if plans and len(plans) > 9:
      await update.message.edit_text("حداکثر پلن‌های ممکن تعریف شده است، لطفا ابتدا یکی را حذف کنید")
      service_repo.user_service.set_state(user_id, States.ADMIN_STARTED)
      await update.message.reply_text(text=main_menu["text"], reply_markup=main_menu["reply_markup"])
      return
    await update.message.edit_text(text="لطفا نام پلن را وارد کنید")
    service_repo.user_service.set_state(user_id, States.ADMIN_SETTING_PLAN_NAME)
  
  elif data == "back":
    service_repo.user_service.set_state(user_id, States.ADMIN_STARTED)
    await update.message.reply_text(text=main_menu["text"], reply_markup=main_menu["reply_markup"])