from pyrogram.client import Client
from pyrogram.types import InlineKeyboardButton, InlineKeyboardMarkup

from common.config import Config

async def check_forced_sub(bot: Client, user_id, chat_id, db_conf, app_conf: Config):
  if user_id in app_conf.admin_user_ids:
    return False
  if db_conf and db_conf["sub_required"] and len(db_conf["channels"]):
    sub_needed = []
    for i in range(len(db_conf["channels"])):
      try:
        await bot.get_chat_member(chat_id=db_conf["channels"][i], user_id=user_id)
      except Exception as e:
        chat = await bot.get_chat(chat_id=db_conf["channels"][i])
        sub_needed.append({ "title": chat.title, "link": db_conf["channel_links"][i]})

    if len(sub_needed):
      reply_markup = []
      for s in sub_needed:
        reply_markup.append([InlineKeyboardButton(
          text=s["title"], url=s["link"]
        )])
      reply_markup.append([InlineKeyboardButton(
        text="عضو شدم", callback_data="subscribed"
      )])
      await bot.send_message(
        chat_id=chat_id,
        text="برای ادامه کار لطفا در کانال‌های زیر عضو شوید و سپس دوباره امتحان کنید",
        reply_markup=InlineKeyboardMarkup(reply_markup)
      )
      return True
      