from pyrogram.types import Message, CallbackQuery

from services.repo import ServiceRepo
from data.main_menu import main_menu
from data.plan_info import plan_info
from common.states import States

async def handle_message(message: Message, service_repo: ServiceRepo):
  pass

async def handle_callback_query(callback: CallbackQuery, service_repo: ServiceRepo):
  data = callback.data
  user_id = callback.from_user.id

  if data == "back":
    service_repo.user_service.set_state(user_id, States.STARTED)
    await callback.message.edit_text(
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )
  elif data.startswith("view_plan:"):
    _, plan_id = data.split(":")
    plan_id = int(plan_id)
    plan = service_repo.plan_service.get_plan(plan_id)
    if not plan:
      await callback.message.edit_text(text="طرح یافت نشد")
      service_repo.user_service.set_state(user_id, States.STARTED)
      await callback.message.reply_text(
        text=main_menu["text"],
        reply_markup=main_menu["reply_markup"]
      )

    dialog = plan_info(plan)
    service_repo.user_service.set_state(user_id, States.VIEWING_PLAN_INFO)
    await callback.message.edit_text(text=dialog["text"], reply_markup=dialog["reply_markup"])
    