from pyrogram.client import Client
from pyrogram.types import CallbackQuery
from services.repo import ServiceRepo
from common.quality import Quality
from common.states import States
from common.config import Config
from data.main_menu import main_menu

async def handle_callback_query(bot: Client, callback: CallbackQuery, service_repo: ServiceRepo, db_conf, app_conf: Config):
  data = callback.data
  user_id = callback.from_user.id
  if data == 'mp3_128':
    service_repo.user_service.set_quality(user_id, Quality.MP3_128)
  elif data == 'mp3_320':
    service_repo.user_service.set_quality(user_id, Quality.MP3_320)
  elif data == 'flac':
    plan = service_repo.plan_member_service.get_user_plan(callback.from_user.id)
    if not(user_id in app_conf.admin_user_ids) and db_conf["plans_enabled"] and not plan:
      service_repo.user_service.set_quality(user_id, Quality.MP3_320)
      await callback.message.edit_text(
        text="برای فعال‌سازی دانلود با حداکثر کیفیت، باید اشتراک ربات را خریداری نمایید"
      )
      await callback.message.reply_text(
        text=main_menu["text"],
        reply_markup=main_menu["reply_markup"]
      )
      service_repo.user_service.set_state(user_id, States.STARTED)
      return

    service_repo.user_service.set_quality(user_id, Quality.FLAC)
  
  service_repo.user_service.set_state(user_id, States.STARTED)
  await bot.edit_message_text(
    chat_id=user_id,
    message_id=callback.message.id,
    text=main_menu["text"],
    reply_markup=main_menu["reply_markup"]
  )
