from pyrogram.types import Message, CallbackQuery

from services.repo import ServiceRepo
from data.main_menu import main_menu
from data.plan_list import plan_list
from common.states import States

async def handle_message(message: Message, service_repo: ServiceRepo):
  pass

async def handle_callback_query(callback: CallbackQuery, service_repo: ServiceRepo):
  data = callback.data
  user_id = callback.from_user.id

  if data == "back":
    service_repo.user_service.set_state(user_id, States.STARTED)
    await callback.message.edit_text(text=main_menu["text"], reply_markup=main_menu["reply_markup"])
  elif data == "buy":
    plans = service_repo.plan_service.get_plans()
    if not plans or not len(plans):
      await callback.message.edit_text(text="هیچ پلنی تعریف نشده است")
      service_repo.user_service.set_state(user_id, States.STARTED)
      await callback.message.reply_text(
        text=main_menu["text"],
        reply_markup=main_menu["reply_markup"]
      )
      return

    dialog = plan_list(plans)
    service_repo.user_service.set_state(user_id, States.CHOOSING_PLAN)
    await callback.message.edit_text(
      text=dialog["text"],
      reply_markup=dialog["reply_markup"]
    )
