from pyrogram.types import Message, CallbackQuery

from services.repo import ServiceRepo
from data.main_menu import main_menu
from data.plan_info import plan_info
from common.states import States

async def handle_message(message: Message, service_repo: ServiceRepo):
  pass

async def handle_callback_query(callback: CallbackQuery, service_repo: ServiceRepo):
  data = callback.data
  user_id = callback.from_user.id

  if data == "back":
    service_repo.user_service.set_state(user_id, States.STARTED)
    await callback.message.edit_text(
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )
  elif data.startswith("buy:"):
    _, plan_id = data.split(":")
    plan_id = int(plan_id)
    current_plan = service_repo.plan_member_service.get_user_plan(user_id)
    if current_plan:
      service_repo.user_service.set_state(user_id, States.STARTED)
      await callback.message.edit_text(text="در حال حاضر پلن فعالی برای شما وجود دارد. بعد از پایان مدت زمان پلن، نسبت به خرید پلن جدید اقدام کنید")
      await callback.message.reply_text(
        text=main_menu["text"],
        reply_markup=main_menu["reply_markup"]
      )
      return

    if service_repo.plan_member_service.register(user_id, plan_id):
      service_repo.user_service.set_state(user_id, States.STARTED)
      await callback.message.edit_text(text="پلن شما ثبت شد!")
      await callback.message.reply_text(
        text=main_menu["text"],
        reply_markup=main_menu["reply_markup"]
      )
      return
    
    service_repo.user_service.set_state(user_id, States.STARTED)
    await callback.message.edit_text(text="در ثبت پلن خطایی پیش آمد، لطفا بعدا مجددا امتحان کنید")
    await callback.message.reply_text(
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )
    return

    