from pyrogram.types import Message, CallbackQuery, InlineKeyboardButton, InlineKeyboardMarkup
from pyrogram.client import Client
from services.repo import ServiceRepo
from common.states import States
from common.quality import Quality
from common.config import Config
from data.main_menu import main_menu
from utils import spotify as spotify_util

async def handle_message(bot: Client, message: Message, service_repo: ServiceRepo, db_conf, app_conf: Config):
  # plan = service_repo.plan_member_service.get_user_plan(message.from_user.id)
  # if not plan:
  #   service_repo.user_service.set_state(message.from_user.id, States.VIEWING_PLAN)
  #   await message.reply_text(
  #     text="برای استفاده از این قسمت باید اشتراک ربات را خریداری کنید",
  #     reply_markup=InlineKeyboardMarkup([[
  #       InlineKeyboardButton(text="خرید پلن", callback_data="buy"),
  #       InlineKeyboardButton(text="بازگشت", callback_data="back"),
  #     ]])
  #   )
  #   return

  extracted_link = spotify_util.extract_spotify_link(message.text)
  if extracted_link == None:
    await service_repo.spotify_service.spotify_search(bot, message, message.text, None, service_repo.user_service)
    return
  
  #Download directly and send
  quality = service_repo.user_service.get_quality(message.from_user.id)
  plan = service_repo.plan_member_service.get_user_plan(message.from_user.id)
  if not(message.from_user.id in app_conf.admin_user_ids) and db_conf["plans_enabled"] and quality == Quality.FLAC and not plan:
    await message.reply_text(
      text="برای دانلود با بالاترین کیفیت، اشتراک ربات را خریداری کنید. تنظیمات کیفیت دانلود به MP3 320 تغییر یافت"
    )
    quality = Quality.MP3_320
    service_repo.user_service.set_quality(message.from_user.id, Quality.MP3_320)

  await service_repo.spotify_service.spotify_dl(
    bot,
    message,
    None,
    extracted_link,
    quality,
    service_repo.user_service,
    service_repo.music_service
  )

async def handle_callback_query(bot: Client, callback: CallbackQuery, service_repo: ServiceRepo):
  if callback.data == 'back':
    service_repo.user_service.set_state(callback.from_user.id, States.STARTED)
    await bot.edit_message_text(
      chat_id=callback.message.chat.id,
      message_id=callback.message.id,
      text=main_menu["text"],
      reply_markup=main_menu["reply_markup"]
    )
