from dotenv import load_dotenv
load_dotenv()

from os import mkdir, path
from common.config import Config
from common.db_manager import DbManager
from init import spotify_client as spotify_client_initializer
from init import bot as bot_initializer
from services.repo import ServiceRepo

def main():
  app_conf = Config()
  if not path.exists(app_conf.tmp_dir):
    mkdir(app_conf.tmp_dir)
  if not path.exists(path.join(app_conf.tmp_dir, 'thumbnails')):
    mkdir(path.join(app_conf.tmp_dir, 'thumbnails'))

  db_manager = DbManager(app_conf)
  spotify_client = spotify_client_initializer.init()
  service_repo = ServiceRepo(db_manager, spotify_client, app_conf)
  bot_initializer.init(app_conf, service_repo)

if __name__ == "__main__":
  main()
