from common.db_manager import DbManager

class DbConfService:
  def __init__(self, db_manager: DbManager):
    self.db_manager = db_manager

  def get_conf(self):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    cursor.execute("SELECT id, sub_required, channels, channel_links, plans_enabled FROM config WHERE id = 1;")
    config = cursor.fetchall()
    db.close()

    if not config or not len(config):
      return None
    
    if config[0][1]:
      sub_required = True
      if config[0][2]:
        channels = config[0][2].split(",")
        channel_links = config[0][3].split(",")
    else:
      sub_required = False
      channels = None
      channel_links = None

    return {
      "sub_required": sub_required,
      "channels": channels,
      "channel_links": channel_links,
      "plans_enabled": config[0][4]
    }

  def toggle_plans(self, enable: bool):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    if enable:
      cursor.execute("UPDATE config SET plans_enabled = 1;")
    else:
      cursor.execute("UPDATE config SET plans_enabled = 0;")
    db.commit()
    db.close()
