from common.db_manager import DbManager
from common.config import Config
from lyricsgenius import Genius

class LyricsService:
  def __init__(self, db_manager: DbManager, config: Config):
    self.db_manager = db_manager
    self.client = Genius(config.genius_access_token)

  def get_lyrics(self, spot_id):
    db = self.db_manager.get_connection()
    cursor = db.cursor()
    cursor.execute(f"""
SELECT lyrics
FROM lyrics
WHERE spot_id = '{spot_id}';
""")
    lyrics = cursor.fetchall()
    db.close()
    if not lyrics or not len(lyrics):
      return None
    return lyrics[0][0]

  def get_lyrics_via_api(self, artist, name):
    retry_count = 0
    while retry_count < 5:
      try:
        song = self.client.search_song(name, artist)
        if song and song.lyrics:
          lyrics = song.lyrics.splitlines()
          final_lyrics = ''
          if lyrics[0] and lyrics[0].find('Contributor') < 0:
            final_lyrics = final_lyrics + lyrics[0] + '\n'

          for idx in range(len(lyrics)):
            if idx == 0:
              continue
            final_lyrics = final_lyrics + lyrics[idx] + '\n'
          
          return final_lyrics
        return None
      except:
        retry_count = retry_count + 1

  def save_lyrics(self, spot_id, lyrics):
    print(lyrics)
    lyrics = str(lyrics)
    spot_id = str(spot_id)
    db = self.db_manager.get_connection()
    cursor = db.cursor()
    query = ('INSERT INTO lyrics ', '(spot_id, lyrics) ', 'VALUES (%s, %s) ', 'ON DUPLICATE KEY UPDATE lyrics = %s;')
    params = (spot_id, lyrics, lyrics)
    cursor.execute(query, params)
    db.commit()
    db.close()
