from common.db_manager import DbManager

class PlanService:
  def __init__(self, db_manager: DbManager):
    self.db_manager = db_manager

  def get_plans(self):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    cursor.execute("SELECT id, name, duration_days, price, discount FROM plan;")
    plans = cursor.fetchall()
    db.close()

    if not plans or not len(plans):
      return None

    result = []
    for plan in plans:
      result.append({
        "id": int(plan[0]),
        "name": plan[1],
        "duration_days": plan[2],
        "price": plan[3],
        "discount": plan[4],
      })

    return result

  def get_plan(self, id):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    cursor.execute(f"SELECT id, name, duration_days, price, discount FROM plan WHERE id = {id};")
    plan = cursor.fetchall()
    db.close()

    if not plan or not len(plan):
      return None

    plan = plan[0]
    return {
      "id": int(plan[0]),
      "name": plan[1],
      "duration_days": plan[2],
      "price": plan[3],
      "discount": plan[4],
    }

  def create_plan(self, name):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    cursor.execute(f"INSERT INTO plan (name, duration_days, price) VALUES ('{name}', 0, 0);")
    db.commit()
    db.close()

  def set_price(self, price):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    cursor.execute("SELECT id FROM plan ORDER BY ID DESC LIMIT 1;")
    plan = cursor.fetchall()
    if not plan or not len(plan):
      db.close()
      return
    
    cursor.execute(f"""
UPDATE plan SET price = {price} WHERE id = {plan[0][0]}    
""")
    db.commit()
    db.close()
