from common.db_manager import DbManager
from time import time
from math import ceil

class PlanMemberService:
  def __init__(self, db_manager: DbManager):
    self.db_manager = db_manager

  def register(self, user_id, plan_id):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    cursor.execute(f"""
SELECT duration_days FROM plan WHERE id = {plan_id};
""")
    plan = cursor.fetchall()
    if not plan or not len(plan):
      db.close()
      return False

    start_date = round(time() * 1000)
    end_date = start_date + (int(plan[0][0]) * 24 * 60 * 60 * 1000)
    cursor.execute(f"""
INSERT INTO plan_member (user_id, plan_id, start_date, end_date)
VALUES ({user_id}, {plan_id}, {start_date}, {end_date})
ON DUPLICATE KEY UPDATE start_date = {start_date}, end_date = {end_date}
""")
    db.commit()
    db.close()
    return True

  def get_user_plan(self, user_id):
    db = self.db_manager.get_connection()
    cursor = db.cursor()

    cursor.execute(f"SELECT user_id, plan_id, start_date, end_date FROM plan_member WHERE user_id = {user_id}")
    plan_member = cursor.fetchall()

    if not plan_member or not len(plan_member):
      db.close()
      return None
    
    start_date = int(plan_member[0][2])
    end_date = int(plan_member[0][3])
    now = round(time() * 1000)
    if start_date <= now and end_date > now:
      cursor.execute(f"""
SELECT name FROM plan WHERE id = {plan_member[0][1]};
""")
      plan = cursor.fetchall()
      if not plan or not len(plan):
        return None
      
      db.close()
      return {
        "name": plan[0][0],
        "remaining": ceil((end_date - now) / (24 * 60 * 60 * 1000))
      }
    
    db.close()
    return None
