from services.user import UserService
from services.spotify import SpotifyService
from services.music import MusicService
from services.movie import MovieService
from services.db_conf import DbConfService
from services.lyrics import LyricsService
from services.plan import PlanService
from services.plan_member import PlanMemberService

from common.config import Config
from common.db_manager import DbManager

class ServiceRepo:
  user_service = None
  spotify_service = None

  def __init__(self, db_manager: DbManager, spotify_client, config: Config):
    self.user_service = UserService(db_manager)
    self.spotify_service = SpotifyService(spotify_client, config)
    self.music_service = MusicService(db_manager)
    self.movie_service = MovieService(db_manager)
    self.db_conf_service = DbConfService(db_manager)
    self.lyrics_service = LyricsService(db_manager, config)
    self.plan_service = PlanService(db_manager)
    self.plan_member_service = PlanMemberService(db_manager)
