from common.states import States
from common.quality import Quality
from common.db_manager import DbManager
from datetime import datetime, timedelta

class UserService:
  def __init__(self, db_manager: DbManager):
    self.db_manager = db_manager

  def find_by_id(self, id):
    db = self.db_manager.get_connection()
    cursor = db.cursor()
    cursor.execute(f"SELECT id, state, quality FROM `bot_user` WHERE id = '{id}';")
    user = cursor.fetchall()
    db.close()
    if not user or not len(user):
      return None
    if user[0][2] == None:
      return {
        "id": user[0][0],
        "state": user[0][1],
        "quality": Quality.MP3_320
      }
    return {
      "id": user[0][0],
      "state": user[0][1],
      "quality": Quality[user[0][2]]
    }
  
  def get_users(self, offset, limit):
    db = self.db_manager.get_connection()
    cursor = db.cursor()
    cursor.execute(f"SELECT id FROM bot_user ORDER BY id LIMIT {limit} OFFSET {offset};")
    users = cursor.fetchall()
    db.close()
    return users

  def get_state(self, id):
    user = self.find_by_id(id)
    if not user:
      return States.NULL
    if not user["state"] in States.__members__:
      return States.NULL
    return States[user["state"]]

  def set_state(self, id, state: States):
    db = self.db_manager.get_connection()
    cursor = db.cursor()
    cursor.execute(f"""
INSERT INTO bot_user(
  id, state
) VALUES (
  '{id}', '{state.name}'
) ON DUPLICATE KEY UPDATE state = '{state.name}';
    """)
    db.commit()
    db.close()

  def set_quality(self, id, quality: Quality):
    db = self.db_manager.get_connection()
    cursor = db.cursor()
    cursor.execute(f"""
UPDATE bot_user
SET quality = '{quality.name}'
WHERE id = '{id}';
""")
    db.commit()
    db.close()

  def get_quality(self, id):
    user = self.find_by_id(id)
    if not user:
      return Quality.MP3_320
    return user["quality"]

  def get_user_count(self):
    db = self.db_manager.get_connection()
    cursor = db.cursor()
    cursor.execute("SELECT COUNT(*) FROM bot_user;")
    result = cursor.fetchall()
    if not result or not len(result):
      all_users = 0
    all_users = int(result[0][0])

    last_week = (datetime.now() + timedelta(days=-7)).strftime('%Y-%m-%d %H:%M:%S')
    cursor.execute(f"SELECT COUNT(*) FROM bot_user WHERE last_update > '{last_week}'")
    result = cursor.fetchall()
    if not result or not len(result):
      last_week_users = 0
    last_week_users = int(result[0][0])

    last_month = (datetime.now() + timedelta(days=-30)).strftime('%Y-%m-%d %H:%M:%S')
    cursor.execute(f"SELECT COUNT(*) FROM bot_user WHERE last_update > '{last_month}'")
    result = cursor.fetchall()
    if not result or not len(result):
      last_month_users = 0
    last_month_users = int(result[0][0])
    cursor.close()

    return {
      "all_users": all_users,
      "last_week_users": last_week_users,
      "last_month_users": last_month_users
    }
